-[_Parcours Open Classrooms_](https://openclassrooms.com/fr/projects/utilisez-les-donnees-publiques-de-lopenfoodfacts "Utilisez les données publiques de l'OpenFoodFact")-

# [PyDev] Projet 5

## Utilisez les données publiques d'[Open Food Facts][3]

_La dernière version à jour de ce document est disponible sur [github](https://github.com/freezed/ocp5/blob/master/README.md)._

---
## Énoncé

> La startup _Pur Beurre_ travaille connait bien les habitudes alimentaires françaises. Leur restaurant, _Ratatouille_, remporte un succès croissant et attire toujours plus de visiteurs sur la butte de Montmartre.

> L'équipe a remarqué que leurs utilisateurs voulaient bien changer leur alimentation mais ne savaient pas bien par quoi commencer. Remplacer le Nxxxxxa par une pâte aux noisettes, oui, mais laquelle? Et dans quel magasin l'acheter? Leur idée est donc de créer un système qui interagirait avec la base [Open Food Facts][3] pour en récupérer les aliments, les comparer et proposer à l'utilisateur un substitut plus sain à l'aliment qui lui fait envie.

## Fonctionnalités

- Recherche d'aliments alternatif dans la base [Open Food Facts][3]
- Affichage de fiches produits
- L'utilisateur :
    * Interagit avec le système dans le terminal
    * Enregistre les produits pour les retrouver plus tard
- L'utilisateur choisi en tapant des un chiffres

## Etapes

1. Plannifier le travail
2. L'organiser dans un [tableau agile][5]
3. Écrire [la documentation][9]
4. Coder

## Contraintes

- Code écrit en anglais : variables, noms de fonctions, commentaires, documentation, ...
- Projet sera versionné et publié sur Github
- Données stockée dans une BDD MySQL

## Livrables

- [Code source publié sur _Github_][4]
- [Tableau agile][5]
- [Modèle physique de données][6]
- Script de création de votre base de données
- [Document texte expliquant la démarche][8]
    * difficultés rencontrées / solutions trouvées
    * lien _Github_
    * développez le choix de l'algorithme et la méthodologie choisie
    * format pdf n'éxcédant pas 2 pages A4
    * rédigé en anglais ou français (les fautes seront évaluées)

[1]: https://guides.github.com/features/mastering-markdown/
[2]: http://en.wiki.openfoodfacts.org/Project:API
[3]: https://fr.openfoodfacts.org/
[4]: https://github.com/freezed/ocp5/blob/master/README.md
[5]: https://github.com/freezed/ocp5/projects/1
[6]: https://github.com/freezed/ocp5/blob/master/doc/pdm.png
[7]: https://github.com/freezed/ocp5/blob/master/create-db.sql
[8]: https://github.com/freezed/ocp5/blob/master/doc/approach.md
[9]: https://github.com/freezed/ocp5/blob/master/doc/documentation.md#documentation "Project documentation"
